#!/usr/bin/env python
# -*- coding: utf-8 -*-
# @Time : 2021/9/5 12:07 上午
# @Author : LeiXueWei
# @CSDN/Juejin/Wechat: 雷学委
# @XueWeiTag: CodingDemo
# @File : main.py
# @Project : pypi_seed
import os

TEMPLATE = """
setup(name='%s',  # 包名
      version='0.0.1',  # 版本号
      description='Sample project generated by pypi_seed',
      long_description="Powered by py4ever team!",
      author='%s',
      author_email='youremail@qq.com',
      url='your-professional-site',
      install_requires=[],
      license='Apache License 2.0',
      packages=find_packages(),
      platforms=["all"],
      classifiers=[
          'Intended Audience :: Developers',
          'Operating System :: OS Independent',
          'Natural Language :: Chinese (Simplified)',
          'Programming Language :: Python',
          'Programming Language :: Python :: 2',
          'Programming Language :: Python :: 2.7',
          'Programming Language :: Python :: 3',
          'Programming Language :: Python :: 3.5',
          'Programming Language :: Python :: 3.6',
          'Programming Language :: Python :: 3.7',
          'Programming Language :: Python :: 3.8',
          'Programming Language :: Python :: 3.9',
          'Topic :: Software Development :: Libraries'
      ],
      )
"""

README = """
# %s
一个pypi的项目模板（种子项目）
Please note the sample project generated by pypi_seed team

# More Info
Author %s
"""


def main():
    print("pypi_seed 种子项目")
    print("欢迎关注公众号【雷学委】【孤寒】【布小禅】，加入Python开发者阵营！")
    print("===========================================")
    print("如何创建项目：")
    print("1）打开python终端REPL：")
    print("2）输入下面代码：")
    print("import pypi_seed.main as pm")
    print("pm.generate() #当前目录生成pypi_sample")
    print("#或者加一个路径参数")
    print("pm.generate('/tmp') #当前目录生成/tmp/pypi_sample")
    print("#或者指定更多项目信息：")
    print("pm.generate(path=\".\", project=\"pypi_sample\", author=\"pypi_seed\") #当前目录生成/tmp/pypi_sample，作者pypi_sample")
    print("===========================================")
    print("其他问题可以找qq：【Python全栈技术学习交流】：https://jq.qq.com/?_wv=1027&k=ISjeG32x ")
    print("===========================================")


def generate(path=".", project="pypi_sample", author="pypi_seed"):
    seed_dir = os.path.join(path, project)
    print("will generate project at %s " % seed_dir)
    if os.path.exists(seed_dir):
        print("project is already generated")
        return
    os.mkdir(seed_dir)
    setup_py = os.path.join(seed_dir, "setup.py")
    data = TEMPLATE % (project, author)
    with open(setup_py, "w") as file:
        file.write(data)
    print("[generation] %s created" % setup_py)
    readme = os.path.join(seed_dir, "README.m")
    data = README % (project, author)
    with open(readme, "w") as file:
        file.write(data)
    print("[generation] %s created" % readme)
    module_dir = os.path.join(seed_dir, project)
    try:
        if not os.path.exists(module_dir):
            os.mkdir(module_dir)
    except Exception as e:
        print("[warning] %s" % str(e))
    print("cool, now your turn to work on your pypi lib as all completed.")
    print("further discussion please contact qq group [Python全栈技术学习交流] or https://jq.qq.com/?_wv=1027&k=ISjeG32x")


if __name__ == '__main__':
    main()
    #generate(path="/tmp")
